<template lang="html">
  <div class="question-answer">
    <div class="control">
      <label for="questionselector">Perguntas Disponíveis</label>
      <div class="select is-fullwidth">
        <select
          id="questionselector"
          v-model="currentQuestion"
          @change="addQuestion"
          :disabled="disableQuestionsSelect"
        >
          <option selected disabled value="">Clique aqui para selecionar uma pergunta</option>
          <option v-for="item in orderQuestions" :value="item">{{item.title}}</option>
        </select>
      </div>
    </div>
    <div class="answered">
      <h2 style="font-weight: bold">Perguntas Respondidas</h2>
      <p v-if="noquestions" class="noquestions cinza-3">
        Nenhuma pergunta respondida.
      </p>
      <div class="form-group" v-for="(item, index) in answeredQuestions">
        <label :for="'anwser-'+index" style="font-weight: bold; display: block">{{item.q}}</label>
        <span class="help-block" v-if="item.help">{{item.help}}</span>
        <div class="anwser-text" v-show="!item.showField">
          {{answeredQuestions[index].text}}
          <div class="text-right action-btns">
            <button class="button is-primary is-small" @click="editAnswer(item)">Editar</button>
            <button class="button is-danger is-small" @click="removeAnswer(item)">Remover</button>
          </div>
        </div>

        <div class="control">
          <textarea
            :id="'anwser-'+index"
            ref="anwsertextarea"
            v-model="answeredQuestions[index].text"
            rows="4"
            class="textarea"
            v-show="item.showField">
          </textarea>
          <!-- <span class="is-pulled-right" style="font-size: 12px">
            <charcount
              :dataString="answeredQuestions[index].text"
              :countdown="500"
              suffix=" caracteres restantes"
            />
          </span> -->
        </div>

        
        <div class="has-text-right action-btns" v-show="item.showField">
          <button class="button is-primary" @click="saveAnswer(item)" :disabled="disableSaveBtn(item)">Salvar</button>
          <button class="button is-danger" @click="cancelAnswer(item)">Cancelar</button>
        </div>
      </div>
    </div>
    <alert v-if="alertCtrl.show" :closable="true" :type="alertCtrl.type" @on-close="alertCtrl.show = false">
      {{alertCtrl.text}}
    </alert>

  </div>
</template>

<script>
  import charcount from './char-count-component.vue'
  import {removeAnswer, editAnswer, saveAnswer, getAnswers} from '../api/answer.service.js'

  export default {
    name: "QuestionAnswerComponent",
    components: { charcount },
    props: {
      questions: {
        type: Array,
        required: true
      },
      solutionId: {
        required: true
      }
    },
    data() {
      return {
        answeredQuestionsCount: 0,
        currentQuestion: '',
        answeredQuestions: [],
        disableQuestionsSelect: false,
        alertCtrl: {
          show: true,
          text: "Você precisa responder pelo menos uma pergunta para continuar",
          type: "warning"
        }
      }
    },
    computed: {
      noquestions: function() {
        if (this.answeredQuestions.length > 0) {
          return false;
        }
        return true;
      },
      orderQuestions: function() {
        return this.questions.sort(function(a, b) {
          let x = a['order'];
          let y = b['order'];
          return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        })
      }
    },
    methods: {
      _getAnswers () {
        getAnswers(this.solutionId)
          .then(
            success => {
              if (success.data.total > 0) {
                this.alertCtrl.show = false
                let questions = []
                success.data.items.map((item) => {
                  let q = {
                    q: item.question.title,
                    order: item.question.order,
                    answerId: item.id,
                    backupText: '',
                    isEditing: false,
                    questionId: item.question.id,
                    showField: false,
                    text: item.text
                  }
                  questions.push(q);
                  this.answeredQuestionsCount++
                })
                this.answeredQuestions = questions
                this.$emit('input', { count: this.answeredQuestionsCount })
              }
            }
          )
      },
      addQuestion: function() {
        this.disableQuestionsSelect = true;
        let o = {
          q: this.currentQuestion.title,
          questionId: this.currentQuestion.id,
          order: this.currentQuestion.order,
          text: '',
          backupText: '',
          showField: true,
          isEditing: false,
          help: this.currentQuestion.help
        }
        this.answeredQuestions.unshift(o);
        setTimeout(() => {
          let idx = this.answeredQuestions.indexOf(o);
          this.$refs.anwsertextarea[idx].focus();
          let index = this.orderQuestions.indexOf(this.currentQuestion);
          this.orderQuestions.splice(index, 1);
        }, 10)
      },
      cancelAnswer: function(item) {
        if (!item.isEditing) {
          let idx = this.answeredQuestions.indexOf(item);
          this.answeredQuestions.splice(idx, 1);
          let o = {
            id: item.questionId,
            title: item.q,
            order: item.order,
          }
          this.orderQuestions.push(o);
        }
        item.text = item.backupText;
        item.showField = false;
        item.isEditing = false;
        this.disableQuestionsSelect = false;
        this.currentQuestion = '';
      },
      removeAnswer: function(item) {
        removeAnswer(item.answerId, this.solutionId)
          .then(
            success => {
              this.cancelAnswer(item);
              this.answeredQuestionsCount--;
              this.$emit('input', { count: this.answeredQuestionsCount });
              if (this.answeredQuestionsCount == 0) {
                this.alertCtrl.show = true;
              }
            }
          )
      },
      saveAnswer: function(item) {
        let data = JSON.parse(JSON.stringify(item));
        let isEdit = data.isEditing
        delete data.backupText
        delete data.isEditing
        delete data.q
        delete data.help
        delete data.order
        delete data.showField
        delete data.answerId
        if (isEdit) {
          delete data.questionId;
          editAnswer(item.answerId, this.solutionId, data)
            .then(
              success => {}
            )
        } else {
          saveAnswer(this.solutionId, data)
            .then(
              success => {
                let idx = this.answeredQuestions.indexOf(item);
                this.answeredQuestions[idx].answerId = success.data.id;
                this.answeredQuestionsCount++;
                this.$emit('input', { count: this.answeredQuestionsCount });
              }
            )
        }
        item.showField = false;
        item.isEditing = false;
        this.disableQuestionsSelect = false;
        this.currentQuestion = '';
        this.alertCtrl.show = false;
      },
      editAnswer: function(item) {
        let i = 0;
        this.answeredQuestions.map(answer => {
          this.answeredQuestions[i].isEditing = false;
          this.answeredQuestions[i].showField = false;
          i++;
        })
        item.showField = true;
        item.isEditing = true;
        item.backupText = item.text;
        this.disableQuestionsSelect = true;
        this.currentQuestion = '';
      },
      disableSaveBtn: function(item) {
        if (item.text.length == 0) {
          return true;
        }
        return false;
      }
    },
    mounted () {
      this._getAnswers()
    },
    watch: {
      solutionId(value) {
        if (value) {
          this._getAnswers()
        }
      }
    }
  }
</script>

<style lang="scss">
  .question-answer {
    margin: 30px 0;
    .noquestions {
      font-size: 16px;
      font-weight: bold;
    }
    .redirect-to {
      margin-top: 30px;
    }
    .answered {
      h2 {
        margin: 30px 0;
      }
      .form-group {
        padding-bottom: 15px;
        border-bottom: 1px solid #ccc;
      }
      .action-btns {
        margin-top: 20px;
        .btn.btn-xs {
          padding: 5px 10px;
        }
        .btn.btn-danger {
          background: #F0535D;
        }
      }
    }
  }
</style>
